Index: dnspython-1.12.0/dns/name.py
===================================================================
--- dnspython-1.12.0.orig/dns/name.py
+++ dnspython-1.12.0/dns/name.py
@@ -21,17 +21,23 @@
 @type empty: dns.name.Name object
 """
 
-import cStringIO
+from io import BytesIO
 import struct
 import sys
 import copy
 
-if sys.hexversion >= 0x02030000:
-    import encodings.idna
+import encodings.idna
 
 import dns.exception
 import dns.wiredata
 
+from ._compat import long, binary_type, text_type
+
+try:
+    maxint = sys.maxint
+except:
+    maxint = (1 << (8 * struct.calcsize("P"))) / 2 - 1
+
 NAMERELN_NONE = 0
 NAMERELN_SUPERDOMAIN = 1
 NAMERELN_SUBDOMAIN = 2
@@ -77,16 +83,7 @@ class NoParent(dns.exception.DNSExceptio
     or the empty name."""
     pass
 
-_escaped = {
-    '"' : True,
-    '(' : True,
-    ')' : True,
-    '.' : True,
-    ';' : True,
-    '\\' : True,
-    '@' : True,
-    '$' : True
-    }
+_escaped = bytearray(b'"().;\\@$')
 
 def _escapify(label, unicode_mode=False):
     """Escape the characters in label which need it.
@@ -94,24 +91,38 @@ def _escapify(label, unicode_mode=False)
     characters
     @returns: the escaped string
     @rtype: string"""
-    text = ''
+    if not unicode_mode:
+        text = ''
+        if isinstance(label, text_type):
+            label = label.encode()
+        for c in bytearray(label):
+            packed = struct.pack('!B', c).decode()
+            if c in _escaped:
+                text += '\\' + packed
+            elif c > 0x20 and c < 0x7F:
+                text += packed
+            else:
+                text += '\\%03d' % c
+        return text.encode()
+
+    text = u''
+    if isinstance(label, binary_type):
+        label = label.decode()
     for c in label:
-        if c in _escaped:
-            text += '\\' + c
-        elif ord(c) > 0x20 and ord(c) < 0x7F:
+        if c > u'\x20' and c < u'\x7f':
             text += c
         else:
-            if unicode_mode and ord(c) >= 0x7F:
+            if c >= u'\x7f':
                 text += c
             else:
-                text += '\\%03d' % ord(c)
+                text += u'\\%03d' % c
     return text
 
+
 def _validate_labels(labels):
     """Check for empty labels in the middle of a label sequence,
     labels that are too long, and for too many labels.
     @raises NameTooLong: the name as a whole is too long
-    @raises LabelTooLong: an individual label is too long
     @raises EmptyLabel: a label is empty (i.e. the root label) and appears
     in a position other than the end of the label sequence"""
 
@@ -124,7 +135,7 @@ def _validate_labels(labels):
         total += ll + 1
         if ll > 63:
             raise LabelTooLong
-        if i < 0 and label == '':
+        if i < 0 and label == b'':
             i = j
         j += 1
     if total > 255:
@@ -132,7 +143,17 @@ def _validate_labels(labels):
     if i >= 0 and i != l - 1:
         raise EmptyLabel
 
+
+def _ensure_bytes(label):
+    if isinstance(label, binary_type):
+        return label
+    if isinstance(label, text_type):
+        return label.encode()
+    raise ValueError
+
+
 class Name(object):
+
     """A DNS name.
 
     The dns.name.Name class represents a DNS name as a tuple of labels.
@@ -148,7 +169,7 @@ class Name(object):
         @param labels: the labels
         @type labels: any iterable whose values are strings
         """
-
+        labels = [_ensure_bytes(x) for x in labels]
         super(Name, self).__setattr__('labels', tuple(labels))
         _validate_labels(self.labels)
 
@@ -166,25 +187,25 @@ class Name(object):
         @rtype: bool
         """
 
-        return len(self.labels) > 0 and self.labels[-1] == ''
+        return len(self.labels) > 0 and self.labels[-1] == b''
 
     def is_wild(self):
         """Is this name wild?  (I.e. Is the least significant label '*'?)
         @rtype: bool
         """
 
-        return len(self.labels) > 0 and self.labels[0] == '*'
+        return len(self.labels) > 0 and self.labels[0] == b'*'
 
     def __hash__(self):
         """Return a case-insensitive hash of the name.
         @rtype: int
         """
 
-        h = 0L
+        h = long(0)
         for label in self.labels:
-            for c in label:
-                h += ( h << 3 ) + ord(c.lower())
-        return int(h % sys.maxint)
+            for c in bytearray(label.lower()):
+                h += (h << 3) + c
+        return int(h % maxint)
 
     def fullcompare(self, other):
         """Compare two names, returning a 3-tuple (relation, order, nlabels).
@@ -319,9 +340,9 @@ class Name(object):
         return '<DNS name ' + self.__str__() + '>'
 
     def __str__(self):
-        return self.to_text(False)
+        return self.to_text(False).decode()
 
-    def to_text(self, omit_final_dot = False):
+    def to_text(self, omit_final_dot=False):
         """Convert name to text format.
         @param omit_final_dot: If True, don't emit the final dot (denoting the
         root label) for absolute names.  The default is False.
@@ -329,17 +350,17 @@ class Name(object):
         """
 
         if len(self.labels) == 0:
-            return '@'
-        if len(self.labels) == 1 and self.labels[0] == '':
-            return '.'
+            return b'@'
+        if len(self.labels) == 1 and self.labels[0] == b'':
+            return b'.'
         if omit_final_dot and self.is_absolute():
             l = self.labels[:-1]
         else:
             l = self.labels
-        s = '.'.join(map(_escapify, l))
+        s = b'.'.join(map(_escapify, l))
         return s
 
-    def to_unicode(self, omit_final_dot = False):
+    def to_unicode(self, omit_final_dot=False):
         """Convert name to Unicode text format.
 
         IDN ACE lables are converted to Unicode.
@@ -357,7 +378,8 @@ class Name(object):
             l = self.labels[:-1]
         else:
             l = self.labels
-        s = u'.'.join([_escapify(encodings.idna.ToUnicode(x), True) for x in l])
+        s = u'.'.join([_escapify(encodings.idna.ToUnicode(x), True)
+                      for x in l])
         return s
 
     def to_digestable(self, origin=None):
@@ -381,14 +403,15 @@ class Name(object):
             labels.extend(list(origin.labels))
         else:
             labels = self.labels
-        dlabels = ["%s%s" % (chr(len(x)), x.lower()) for x in labels]
-        return ''.join(dlabels)
+        dlabels = [struct.pack('!B%ds' % len(x), len(x), x.lower())
+                   for x in labels]
+        return b''.join(dlabels)
 
-    def to_wire(self, file = None, compress = None, origin = None):
+    def to_wire(self, file=None, compress=None, origin=None):
         """Convert name to wire format, possibly compressing it.
 
         @param file: the file where the name is emitted (typically
-        a cStringIO file).  If None, a string containing the wire name
+        a BytesIO file).  If None, a string containing the wire name
         will be returned.
         @type file: file or None
         @param compress: The compression table.  If None (the default) names
@@ -403,7 +426,7 @@ class Name(object):
         """
 
         if file is None:
-            file = cStringIO.StringIO()
+            file = BytesIO()
             want_return = True
         else:
             want_return = False
@@ -419,22 +442,22 @@ class Name(object):
         for label in labels:
             n = Name(labels[i:])
             i += 1
-            if not compress is None:
+            if compress is not None:
                 pos = compress.get(n)
             else:
                 pos = None
-            if not pos is None:
+            if pos is not None:
                 value = 0xc000 + pos
                 s = struct.pack('!H', value)
                 file.write(s)
                 break
             else:
-                if not compress is None and len(n) > 1:
+                if compress is not None and len(n) > 1:
                     pos = file.tell()
                     if pos <= 0x3fff:
                         compress[n] = pos
                 l = len(label)
-                file.write(chr(l))
+                file.write(struct.pack('!B', l))
                 if l > 0:
                     file.write(label)
         if want_return:
@@ -476,8 +499,9 @@ class Name(object):
         elif depth == l:
             return (dns.name.empty, self)
         elif depth < 0 or depth > l:
-            raise ValueError('depth must be >= 0 and <= the length of the name')
-        return (Name(self[: -depth]), Name(self[-depth :]))
+            raise ValueError(
+                'depth must be >= 0 and <= the length of the name')
+        return (Name(self[: -depth]), Name(self[-depth:]))
 
     def concatenate(self, other):
         """Return a new name which is the concatenation of self and other.
@@ -498,7 +522,7 @@ class Name(object):
         @rtype: dns.name.Name object
         """
 
-        if not origin is None and self.is_subdomain(origin):
+        if origin is not None and self.is_subdomain(origin):
             return Name(self[: -len(origin)])
         else:
             return self
@@ -540,10 +564,11 @@ class Name(object):
             raise NoParent
         return Name(self.labels[1:])
 
-root = Name([''])
+root = Name([b''])
 empty = Name([])
 
-def from_unicode(text, origin = root):
+
+def from_unicode(text, origin=root):
     """Convert unicode text into a Name object.
 
     Lables are encoded in IDN ACE form.
@@ -551,7 +576,7 @@ def from_unicode(text, origin = root):
     @rtype: dns.name.Name object
     """
 
-    if not isinstance(text, unicode):
+    if not isinstance(text, text_type):
         raise ValueError("input to from_unicode() must be a unicode string")
     if not (origin is None or isinstance(origin, Name)):
         raise ValueError("origin must be a Name or None")
@@ -564,7 +589,7 @@ def from_unicode(text, origin = root):
         text = u''
     if text:
         if text == u'.':
-            return Name([''])	# no Unicode "u" on this constant!
+            return Name([b''])	# no Unicode "u" on this constant!
         for c in text:
             if escaping:
                 if edigits == 0:
@@ -583,8 +608,7 @@ def from_unicode(text, origin = root):
                     if edigits == 3:
                         escaping = False
                         label += chr(total)
-            elif c == u'.' or c == u'\u3002' or \
-                 c == u'\uff0e' or c == u'\uff61':
+            elif c in [u'.', u'\u3002', u'\uff0e', u'\uff61']:
                 if len(label) == 0:
                     raise EmptyLabel
                 labels.append(encodings.idna.ToASCII(label))
@@ -600,72 +624,75 @@ def from_unicode(text, origin = root):
         if len(label) > 0:
             labels.append(encodings.idna.ToASCII(label))
         else:
-            labels.append('')
-    if (len(labels) == 0 or labels[-1] != '') and not origin is None:
+            labels.append(b'')
+
+    if (len(labels) == 0 or labels[-1] != b'') and origin is not None:
         labels.extend(list(origin.labels))
     return Name(labels)
 
-def from_text(text, origin = root):
+
+def from_text(text, origin=root):
     """Convert text into a Name object.
     @rtype: dns.name.Name object
     """
 
-    if not isinstance(text, str):
-        if isinstance(text, unicode) and sys.hexversion >= 0x02030000:
-            return from_unicode(text, origin)
-        else:
-            raise ValueError("input to from_text() must be a string")
+    if isinstance(text, text_type):
+        return from_unicode(text, origin)
+    if not isinstance(text, binary_type):
+        raise ValueError("input to from_text() must be a string")
     if not (origin is None or isinstance(origin, Name)):
         raise ValueError("origin must be a Name or None")
     labels = []
-    label = ''
+    label = b''
     escaping = False
     edigits = 0
     total = 0
-    if text == '@':
-        text = ''
+    if text == b'@':
+        text = b''
     if text:
-        if text == '.':
-            return Name([''])
-        for c in text:
+        if text == b'.':
+            return Name([b''])
+        for c in bytearray(text):
+            byte_ = struct.pack('!B', c)
             if escaping:
                 if edigits == 0:
-                    if c.isdigit():
-                        total = int(c)
+                    if byte_.isdigit():
+                        total = int(byte_)
                         edigits += 1
                     else:
-                        label += c
+                        label += byte_
                         escaping = False
                 else:
-                    if not c.isdigit():
+                    if not byte_.isdigit():
                         raise BadEscape
                     total *= 10
-                    total += int(c)
+                    total += int(byte_)
                     edigits += 1
                     if edigits == 3:
                         escaping = False
-                        label += chr(total)
-            elif c == '.':
+                        label += struct.pack('!B', total)
+            elif byte_ == b'.':
                 if len(label) == 0:
                     raise EmptyLabel
                 labels.append(label)
-                label = ''
-            elif c == '\\':
+                label = b''
+            elif byte_ == b'\\':
                 escaping = True
                 edigits = 0
                 total = 0
             else:
-                label += c
+                label += byte_
         if escaping:
             raise BadEscape
         if len(label) > 0:
             labels.append(label)
         else:
-            labels.append('')
-    if (len(labels) == 0 or labels[-1] != '') and not origin is None:
+            labels.append(b'')
+    if (len(labels) == 0 or labels[-1] != b'') and origin is not None:
         labels.extend(list(origin.labels))
     return Name(labels)
 
+
 def from_wire(message, current):
     """Convert possibly compressed wire format into a Name.
     @param message: the entire DNS message
@@ -681,23 +708,23 @@ def from_wire(message, current):
     @rtype: (dns.name.Name object, int) tuple
     """
 
-    if not isinstance(message, str):
+    if not isinstance(message, binary_type):
         raise ValueError("input to from_wire() must be a byte string")
     message = dns.wiredata.maybe_wrap(message)
     labels = []
     biggest_pointer = current
     hops = 0
-    count = ord(message[current])
+    count = message[current]
     current += 1
     cused = 1
     while count != 0:
         if count < 64:
-            labels.append(message[current : current + count].unwrap())
+            labels.append(message[current: current + count].unwrap())
             current += count
             if hops == 0:
                 cused += count
         elif count >= 192:
-            current = (count & 0x3f) * 256 + ord(message[current])
+            current = (count & 0x3f) * 256 + message[current]
             if hops == 0:
                 cused += 1
             if current >= biggest_pointer:
@@ -706,7 +733,7 @@ def from_wire(message, current):
             hops += 1
         else:
             raise BadLabelType
-        count = ord(message[current])
+        count = message[current]
         current += 1
         if hops == 0:
             cused += 1
Index: dnspython-1.12.0/dns/namedict.py
===================================================================
--- dnspython-1.12.0.orig/dns/namedict.py
+++ dnspython-1.12.0/dns/namedict.py
@@ -16,6 +16,7 @@
 """DNS name dictionary"""
 
 import dns.name
+from ._compat import xrange
 
 class NameDict(dict):
 
@@ -53,7 +54,10 @@ class NameDict(dict):
             depth = self.max_depth
         for i in xrange(-depth, 0):
             n = dns.name.Name(name[i:])
-            if self.has_key(n):
+            if n in self:
                 return (n, self[n])
         v = self[dns.name.empty]
         return (dns.name.empty, v)
+
+    def has_key(self, key):
+        return key in self
Index: dnspython-1.12.0/dns/node.py
===================================================================
--- dnspython-1.12.0.orig/dns/node.py
+++ dnspython-1.12.0/dns/node.py
@@ -15,13 +15,15 @@
 
 """DNS nodes.  A node is a set of rdatasets."""
 
-import StringIO
+from io import StringIO
 
 import dns.rdataset
 import dns.rdatatype
 import dns.renderer
 
+
 class Node(object):
+
     """A DNS node.
 
     A node is a set of rdatasets
@@ -35,7 +37,7 @@ class Node(object):
         """Initialize a DNS node.
         """
 
-        self.rdatasets = [];
+        self.rdatasets = []
 
     def to_text(self, name, **kw):
         """Convert a node to text format.
@@ -47,10 +49,11 @@ class Node(object):
         @rtype: string
         """
 
-        s = StringIO.StringIO()
+        s = StringIO()
         for rds in self.rdatasets:
             if len(rds) > 0:
-                print >> s, rds.to_text(name, **kw)
+                s.write(rds.to_text(name, **kw))
+                s.write(u'\n')
         return s.getvalue()[:-1]
 
     def __repr__(self):
@@ -155,7 +158,7 @@ class Node(object):
         """
 
         rds = self.get_rdataset(rdclass, rdtype, covers)
-        if not rds is None:
+        if rds is not None:
             self.rdatasets.remove(rds)
 
     def replace_rdataset(self, replacement):
@@ -169,7 +172,7 @@ class Node(object):
         """
 
         if not isinstance(replacement, dns.rdataset.Rdataset):
-            raise ValueError, 'replacement is not an rdataset'
+            raise ValueError('replacement is not an rdataset')
         self.delete_rdataset(replacement.rdclass, replacement.rdtype,
                              replacement.covers)
         self.rdatasets.append(replacement)
Index: dnspython-1.12.0/dns/opcode.py
===================================================================
--- dnspython-1.12.0.orig/dns/opcode.py
+++ dnspython-1.12.0/dns/opcode.py
@@ -35,7 +35,7 @@ _by_text = {
 # cannot make any mistakes (e.g. omissions, cut-and-paste errors) that
 # would cause the mapping not to be true inverse.
 
-_by_value = dict([(y, x) for x, y in _by_text.iteritems()])
+_by_value = dict((y, x) for x, y in _by_text.items())
 
 
 class UnknownOpcode(dns.exception.DNSException):
@@ -60,23 +60,26 @@ def from_text(text):
         raise UnknownOpcode
     return value
 
+
 def from_flags(flags):
     """Extract an opcode from DNS message flags.
 
     @param flags: int
     @rtype: int
     """
-    
+
     return (flags & 0x7800) >> 11
 
+
 def to_flags(value):
     """Convert an opcode to a value suitable for ORing into DNS message
     flags.
     @rtype: int
     """
-    
+
     return (value << 11) & 0x7800
-    
+
+
 def to_text(value):
     """Convert an opcode to text.
 
@@ -85,12 +88,13 @@ def to_text(value):
     @raises UnknownOpcode: the opcode is unknown
     @rtype: string
     """
-    
+
     text = _by_value.get(value)
     if text is None:
         text = str(value)
     return text
 
+
 def is_update(flags):
     """True if the opcode in flags is UPDATE.
 
@@ -98,7 +102,7 @@ def is_update(flags):
     @type flags: int
     @rtype: bool
     """
-    
+
     if (from_flags(flags) == UPDATE):
         return True
     return False
Index: dnspython-1.12.0/dns/query.py
===================================================================
--- dnspython-1.12.0.orig/dns/query.py
+++ dnspython-1.12.0/dns/query.py
@@ -31,6 +31,13 @@ import dns.message
 import dns.rdataclass
 import dns.rdatatype
 
+from ._compat import long, string_types
+
+if sys.version_info > (3,):
+    select_error = OSError
+else:
+    select_error = select.error
+
 class UnexpectedSource(dns.exception.DNSException):
     """Raised if a query response comes from an unexpected address or port."""
     pass
@@ -75,6 +82,7 @@ def _poll_for(fd, readable, writable, er
 
     return bool(event_list)
 
+
 def _select_for(fd, readable, writable, error, timeout):
     """Select polling backend.
     @param fd: File descriptor
@@ -103,6 +111,7 @@ def _select_for(fd, readable, writable,
 
     return bool((rcount or wcount or xcount))
 
+
 def _wait_for(fd, readable, writable, error, expiration):
     done = False
     while not done:
@@ -115,11 +124,12 @@ def _wait_for(fd, readable, writable, er
         try:
             if not _polling_backend(fd, readable, writable, error, timeout):
                 raise dns.exception.Timeout
-        except select.error, e:
+        except select_error as e:
             if e.args[0] != errno.EINTR:
                 raise e
         done = True
 
+
 def _set_polling_backend(fn):
     """
     Internal API. Do not use.
@@ -136,12 +146,15 @@ if hasattr(select, 'poll'):
 else:
     _polling_backend = _select_for
 
+
 def _wait_for_readable(s, expiration):
     _wait_for(s, True, False, True, expiration)
 
+
 def _wait_for_writable(s, expiration):
     _wait_for(s, False, True, True, expiration)
 
+
 def _addresses_equal(af, a1, a2):
     # Convert the first value of the tuple, which is a textual format
     # address into binary form, so that we are not confused by different
@@ -150,6 +163,7 @@ def _addresses_equal(af, a1, a2):
     n2 = dns.inet.inet_pton(af, a2[0])
     return n1 == n2 and a1[1:] == a2[1:]
 
+
 def _destination_and_source(af, where, port, source, source_port):
     # Apply defaults and compute destination and source tuples
     # suitable for use in connect(), sendto(), or bind().
@@ -172,6 +186,7 @@ def _destination_and_source(af, where, p
             source = (source, source_port, 0, 0)
     return (af, destination, source)
 
+
 def udp(q, where, timeout=None, port=53, af=None, source=None, source_port=0,
         ignore_unexpected=False, one_rr_per_rrset=False):
     """Return the response obtained after sending a query via UDP.
@@ -203,8 +218,8 @@ def udp(q, where, timeout=None, port=53,
     """
 
     wire = q.to_wire()
-    (af, destination, source) = _destination_and_source(af, where, port, source,
-                                                        source_port)
+    (af, destination, source) = _destination_and_source(af, where, port,
+                                                        source, source_port)
     s = socket.socket(af, socket.SOCK_DGRAM, 0)
     try:
         expiration = _compute_expiration(timeout)
@@ -217,8 +232,8 @@ def udp(q, where, timeout=None, port=53,
             _wait_for_readable(s, expiration)
             (wire, from_address) = s.recvfrom(65535)
             if _addresses_equal(af, from_address, destination) or \
-                    (dns.inet.is_multicast(where) and \
-                         from_address[1:] == destination[1:]):
+                    (dns.inet.is_multicast(where) and
+                     from_address[1:] == destination[1:]):
                 break
             if not ignore_unexpected:
                 raise UnexpectedSource('got a response from '
@@ -232,6 +247,7 @@ def udp(q, where, timeout=None, port=53,
         raise BadResponse
     return r
 
+
 def _net_read(sock, count, expiration):
     """Read the specified number of bytes from sock.  Keep trying until we
     either get the desired amount, or we hit EOF.
@@ -248,6 +264,7 @@ def _net_read(sock, count, expiration):
         s = s + n
     return s
 
+
 def _net_write(sock, data, expiration):
     """Write the specified data to the socket.
     A Timeout exception will be raised if the operation is not completed
@@ -259,16 +276,18 @@ def _net_write(sock, data, expiration):
         _wait_for_writable(sock, expiration)
         current += sock.send(data[current:])
 
+
 def _connect(s, address):
     try:
         s.connect(address)
     except socket.error:
         (ty, v) = sys.exc_info()[:2]
         if v[0] != errno.EINPROGRESS and \
-               v[0] != errno.EWOULDBLOCK and \
-               v[0] != errno.EALREADY:
+            v[0] != errno.EWOULDBLOCK and \
+                v[0] != errno.EALREADY:
             raise v
 
+
 def tcp(q, where, timeout=None, port=53, af=None, source=None, source_port=0,
         one_rr_per_rrset=False):
     """Return the response obtained after sending a query via TCP.
@@ -297,8 +316,8 @@ def tcp(q, where, timeout=None, port=53,
     """
 
     wire = q.to_wire()
-    (af, destination, source) = _destination_and_source(af, where, port, source,
-                                                        source_port)
+    (af, destination, source) = _destination_and_source(af, where, port,
+                                                        source, source_port)
     s = socket.socket(af, socket.SOCK_STREAM, 0)
     try:
         expiration = _compute_expiration(timeout)
@@ -325,6 +344,7 @@ def tcp(q, where, timeout=None, port=53,
         raise BadResponse
     return r
 
+
 def xfr(where, zone, rdtype=dns.rdatatype.AXFR, rdclass=dns.rdataclass.IN,
         timeout=None, port=53, keyring=None, keyname=None, relativize=True,
         af=None, lifetime=None, source=None, source_port=0, serial=0,
@@ -378,20 +398,20 @@ def xfr(where, zone, rdtype=dns.rdatatyp
     @type keyalgorithm: string
     """
 
-    if isinstance(zone, (str, unicode)):
+    if isinstance(zone, string_types):
         zone = dns.name.from_text(zone)
-    if isinstance(rdtype, (str, unicode)):
+    if isinstance(rdtype, string_types):
         rdtype = dns.rdatatype.from_text(rdtype)
     q = dns.message.make_query(zone, rdtype, rdclass)
     if rdtype == dns.rdatatype.IXFR:
         rrset = dns.rrset.from_text(zone, 0, 'IN', 'SOA',
                                     '. . %u 0 0 0 0' % serial)
         q.authority.append(rrset)
-    if not keyring is None:
+    if keyring is not None:
         q.use_tsig(keyring, keyname, algorithm=keyalgorithm)
     wire = q.to_wire()
-    (af, destination, source) = _destination_and_source(af, where, port, source,
-                                                        source_port)
+    (af, destination, source) = _destination_and_source(af, where, port,
+                                                        source, source_port)
     if use_udp:
         if rdtype != dns.rdatatype.IXFR:
             raise ValueError('cannot do a UDP AXFR')
@@ -414,7 +434,6 @@ def xfr(where, zone, rdtype=dns.rdatatyp
     delete_mode = True
     expecting_SOA = False
     soa_rrset = None
-    soa_count = 0
     if relativize:
         origin = zone
         oname = dns.name.empty
@@ -434,16 +453,18 @@ def xfr(where, zone, rdtype=dns.rdatatyp
             ldata = _net_read(s, 2, mexpiration)
             (l,) = struct.unpack("!H", ldata)
             wire = _net_read(s, l, mexpiration)
+        is_ixfr = (rdtype == dns.rdatatype.IXFR)
         r = dns.message.from_wire(wire, keyring=q.keyring, request_mac=q.mac,
                                   xfr=True, origin=origin, tsig_ctx=tsig_ctx,
                                   multi=True, first=first,
-                                  one_rr_per_rrset=(rdtype==dns.rdatatype.IXFR))
+                                  one_rr_per_rrset=is_ixfr)
         tsig_ctx = r.tsig_ctx
         first = False
         answer_index = 0
         if soa_rrset is None:
             if not r.answer or r.answer[0].name != oname:
-                raise dns.exception.FormError("No answer or RRset not for qname")
+                raise dns.exception.FormError(
+                    "No answer or RRset not for qname")
             rrset = r.answer[0]
             if rrset.rdtype != dns.rdatatype.SOA:
                 raise dns.exception.FormError("first RRset is not an SOA")
@@ -467,7 +488,8 @@ def xfr(where, zone, rdtype=dns.rdatatyp
             if rrset.rdtype == dns.rdatatype.SOA and rrset.name == oname:
                 if expecting_SOA:
                     if rrset[0].serial != serial:
-                        raise dns.exception.FormError("IXFR base serial mismatch")
+                        raise dns.exception.FormError(
+                            "IXFR base serial mismatch")
                     expecting_SOA = False
                 elif rdtype == dns.rdatatype.IXFR:
                     delete_mode = not delete_mode
@@ -477,8 +499,8 @@ def xfr(where, zone, rdtype=dns.rdatatyp
                 # the record in the expected part of the response.
                 #
                 if rrset == soa_rrset and \
-                        (rdtype == dns.rdatatype.AXFR or \
-                        (rdtype == dns.rdatatype.IXFR and delete_mode)):
+                        (rdtype == dns.rdatatype.AXFR or
+                         (rdtype == dns.rdatatype.IXFR and delete_mode)):
                     done = True
             elif expecting_SOA:
                 #
Index: dnspython-1.12.0/dns/rcode.py
===================================================================
--- dnspython-1.12.0.orig/dns/rcode.py
+++ dnspython-1.12.0/dns/rcode.py
@@ -16,6 +16,8 @@
 """DNS Result Codes."""
 
 import dns.exception
+from ._compat import long
+
 
 NOERROR = 0
 FORMERR = 1
@@ -49,7 +51,7 @@ _by_text = {
 # cannot make any mistakes (e.g. omissions, cut-and-paste errors) that
 # would cause the mapping not to be a true inverse.
 
-_by_value = dict([(y, x) for x, y in _by_text.iteritems()])
+_by_value = dict((y, x) for x, y in _by_text.items())
 
 
 class UnknownRcode(dns.exception.DNSException):
@@ -74,6 +76,7 @@ def from_text(text):
         raise UnknownRcode
     return v
 
+
 def from_flags(flags, ednsflags):
     """Return the rcode value encoded by flags and ednsflags.
 
@@ -90,6 +93,7 @@ def from_flags(flags, ednsflags):
         raise ValueError('rcode must be >= 0 and <= 4095')
     return value
 
+
 def to_flags(value):
     """Return a (flags, ednsflags) tuple which encodes the rcode.
 
@@ -105,6 +109,7 @@ def to_flags(value):
     ev = long(value & 0xff0) << 20
     return (v, ev)
 
+
 def to_text(value):
     """Convert rcode into text.
 
